/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuServiceLister helps list KukuServices.
type KukuServiceLister interface {
	// List lists all KukuServices in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuService, err error)
	// KukuServices returns an object that can list and get KukuServices.
	KukuServices(namespace string) KukuServiceNamespaceLister
	KukuServiceListerExpansion
}

// kukuServiceLister implements the KukuServiceLister interface.
type kukuServiceLister struct {
	indexer cache.Indexer
}

// NewKukuServiceLister returns a new KukuServiceLister.
func NewKukuServiceLister(indexer cache.Indexer) KukuServiceLister {
	return &kukuServiceLister{indexer: indexer}
}

// List lists all KukuServices in the indexer.
func (s *kukuServiceLister) List(selector labels.Selector) (ret []*v1.KukuService, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuService))
	})
	return ret, err
}

// KukuServices returns an object that can list and get KukuServices.
func (s *kukuServiceLister) KukuServices(namespace string) KukuServiceNamespaceLister {
	return kukuServiceNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuServiceNamespaceLister helps list and get KukuServices.
type KukuServiceNamespaceLister interface {
	// List lists all KukuServices in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuService, err error)
	// Get retrieves the KukuService from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuService, error)
	KukuServiceNamespaceListerExpansion
}

// kukuServiceNamespaceLister implements the KukuServiceNamespaceLister
// interface.
type kukuServiceNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuServices in the indexer for a given namespace.
func (s kukuServiceNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuService, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuService))
	})
	return ret, err
}

// Get retrieves the KukuService from the indexer for a given namespace and name.
func (s kukuServiceNamespaceLister) Get(name string) (*v1.KukuService, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukuservice"), name)
	}
	return obj.(*v1.KukuService), nil
}
